Unit tde45e3_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UtRes_p, Fde45e3_p, DE45E_p;

function tde45e3: String;

implementation

function tde45e3: String;
var
M,K,IMAX,INIAPR,_i :Integer;
XN,H,XK,H0 :Extended;
YN :Array [0..1] of Extended;
Y :Array [0..1] of Extended;
RAB :Array [0..1691] of Extended;
YT :Array [0..1] of Extended;
DELY :Array [0..1] of Extended;
RELERR :Array [0..1] of Extended;
label
_42;
begin
Result := '';  {   }
M := 2;
XN := -3.e0*Sqrt(2.e0);
YN[0] := 3.e0*Exp(XN*XN);
YN[1] := 1.e0/6.e0*Exp(-XN*XN);
YT[0] := 3.e0;
YT[1] := 1.e0/6.e0;
XK := 0.0;
H0 := 0.1e0;
K := 25;
IMAX := 30;
for INIAPR:=1 to 2 do
 begin
  H := H0;
  DE45E(Fde45e3,M,XN,YN,XK,K,INIAPR,IMAX,H,Y,RAB);
  DELY[0] := YT[0]-Y[0];
  DELY[1] := YT[1]-Y[1];
  RELERR[0] := DELY[0]/Y[0];
  RELERR[1] := DELY[1]/Y[1];
  Result := Result + Format(' H0=%20.16f    K=%2d    INIAPR=%1d    IMAX=%3d ',
 [H0,K,INIAPR,IMAX]) + #$0D#$0A;
  Result := Result + Format('%s',[' Y= ']);
  Result := Result + #$0D#$0A;
  for _i:=0 to 1 do
   begin
    Result := Result + Format('%30.18e ',[Y[_i]]);
    if ( ((_i+1) mod 2)=0 )
     then Result := Result + #$0D#$0A;
   end;
  Result := Result + #$0D#$0A;
  Result := Result + Format('%s',[#$0D#$0A + ' YT=']);
  Result := Result + #$0D#$0A;
  for _i:=0 to 1 do
   begin
    Result := Result + Format('%30.18e ',[YT[_i]]);
    if ( ((_i+1) mod 2)=0 )
     then Result := Result + #$0D#$0A;
   end;
  Result := Result + #$0D#$0A;
  Result := Result + Format('%s',[#$0D#$0A + ' DELTA Y  =']);
  Result := Result + #$0D#$0A;
  for _i:=0 to 1 do
   begin
    Result := Result + Format('%30.18e ',[DELY[_i]]);
    if ( ((_i+1) mod 2)=0 )
     then Result := Result + #$0D#$0A;
   end;
  Result := Result + #$0D#$0A;
  Result := Result + Format('%s',[' RELERR   =']);
  Result := Result + #$0D#$0A;
  for _i:=0 to 1 do
   begin
    Result := Result + Format('%30.18e ',[RELERR[_i]]);
    if ( ((_i+1) mod 2)=0 )
     then Result := Result + #$0D#$0A;
   end;
  Result := Result + #$0D#$0A;
  Result := Result + Format('%s',
 [#$0D#$0A + ' ----------------------------------------------------------------']) + #$0D#$0A; 
_42:
 end;
UtRes('tde45e3',Result);  {     tde45e3.res }
exit;
end;

end.
